#!/usr/bin/perl

use warnings;
use Getopt::Long;
use Time::Local;
use File::Copy;


my $lore_string="http://sandoz.zmanda.com/lore/article.php?id=";

#Reads a given option file
#$_[0] specifies file to be read (full path needs to be provided)
sub readOptionsFile()
{

        unless (open(TMPCONF, $_[0])) {
                die("cannot open input options file $_[0]. $!\n");
                return;
        }
        my @tmparr = <TMPCONF>;
        close(TMPCONF);
        chomp (@tmparr);
        my $var1;
        foreach $var1 (@tmparr) {
                #$var1 = &checkForBlank($var1);
                if($var1){
                        my @v=split("=",$var1);
                        my $v1 = shift @v;
			#$v1=~ s/\./\\./;
                        my $v2 = join( "=", @v );
			# escape quotes
			#  $v2=~ s/\"/\\"/g;
			$v2 =~ s/LORE-([0-9][0-9][0-9])/$lore_string$1/;
                        $inputs{$v1}=$v2;
                }
        }
}

#main

print ("translate en.po using ztranslation file...\n");


&readOptionsFile( "./ztranslation" );

my $in_msgstr_sec=0;
my $pre_string='<a target=new href=\"';


open(CONF, "en.po")
  || die ("ERROR: en.po: $!\n");
open(NEWCONF, ">en_ZM.po") ||
  die ("ERROR: Cannot create en_ZM.po: $!\n");
while (<CONF>) {
  $in_msgstr_sec = 1 if ( /^msgstr /);
  $in_msgstr_sec = 0 if ( /^msgid /);
  unless ( /^#/ or $in_msgstr_sec == 0 ) {  # skip comment and msgid
    foreach $org ( keys %inputs ) {
                                                          # don't translate more than once
    s#(^|[\s:])($org)(\b)#$1$pre_string$inputs{$org}\\"\>$2\</a\>$3#i if ( ! /a target=new href/ );
    }
  } # unless
  print NEWCONF $_;
}
close(CONF);
close(NEWCONF);
print ("en_ZM.po created and updated\n");
